//
//  Parser.m
//  Jarnaby
//
//  Created by Shin-Young Jung on 10. 10. 27..
//  Copyright 2010 Brigham Young University Hawaii. All rights reserved.
//

#import "Parser.h"

@implementation Parser
@synthesize title,Links,paths,images,pages,rects,maap;

-(id) init {
	a=0;
	images = [[NSMutableDictionary alloc] init];
	paths = [[NSMutableArray alloc] init];
	maap = [[NSMutableArray alloc] init];
	pages = [[NSMutableArray alloc] init];
	rects = [[NSMutableDictionary alloc] init];
	Links = [[NSMutableDictionary alloc] init];
	title = [[NSString alloc] init];
	[self parseXmLFileAtURL];
	return self;
}

-(void) parseXmLFileAtURL {
	NSURL *xmlURL = [NSURL fileURLWithPath:[[NSBundle mainBundle] pathForResource:@"Irrh" ofType:@"xml"]];
	parser = [[NSXMLParser alloc] initWithContentsOfURL:xmlURL];
	[parser setDelegate:self];
	[parser setShouldProcessNamespaces:NO];
	[parser setShouldReportNamespacePrefixes:NO];
	[parser setShouldResolveExternalEntities:NO];
	[parser parse];
}
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string{
	if([currentElement isEqualToString:@"title"]){
		NSString *e = [string stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
		if([e isEqualToString:@""]){
			return;
		}
		title = [string copy];
	} else if([currentElement isEqualToString:@"text"]){
		NSString *e = [string stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
		if([e isEqualToString:@""]){
			return;
		}
		NSMutableString *htmlstyle =[[NSMutableString alloc] initWithString:[NSString stringWithFormat:@"<p> %@ </p>", string]];
		[[[pages objectAtIndex:[pages count]-1] texts] addObject:htmlstyle];
		
	}

}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict{
	currentElement = [elementName copy];
	//NSLog(@"%@", currentElement);
	NSEnumerator *enumerator = [attributeDict keyEnumerator];
	NSString *key = [[NSString alloc] init];
	NSString *value=[[NSString alloc] init];
	if([currentElement isEqualToString:@"image"]){
		for(NSString *aKey in enumerator){
			if([aKey isEqualToString:@"id"]){
				key = [attributeDict valueForKey:aKey];
			}else if([aKey isEqualToString:@"file"]){
				value=[attributeDict valueForKey:aKey];
			}
		}
		[images setValue:value forKey:key];
	} else if([currentElement isEqualToString:@"page"]){
		int ID;
		NSString * imageID = [[NSString alloc] init];
		for(NSString *aKey in enumerator){
			if([aKey isEqualToString:@"id"]){
				ID=[[attributeDict valueForKey:aKey] integerValue];
			} else if([aKey isEqualToString:@"image_id"]){
				imageID=[attributeDict valueForKey:aKey];
			}
		}
		[pages addObject:[[Page alloc] initwithValue:ID image:[images objectForKey:imageID]]];
	} else if([currentElement isEqualToString:@"link"]){
		for(NSString *aKey in enumerator){
			int th,ge;
			NSMutableString *t;
			if([aKey isEqualToString:@"pathref"]){
				th=[[attributeDict valueForKey:aKey] integerValue];
			}else if([aKey isEqualToString:@"pageref"]){
				ge=[[attributeDict valueForKey:aKey] integerValue];	
			}else if ([aKey isEqualToString:@"text"]){
				t = [attributeDict valueForKey:aKey];
				NSLog(t);
			}
			[Links setValue:[[Link alloc]initWithPathref:th Pageref:ge] forKey:[NSString stringWithFormat:@"%d", [pages count]-1 ] ];
			Link *ell = [Links objectForKey:[NSString stringWithFormat:@"%d", [pages count]-1 ]];
			//[[Links objectForKey:[NSString stringWithFormat:@"%d", [pages count]-1 ]] setName:t]; //this is the problem
			[[pages objectAtIndex:[pages count]-1] setLink];
			
		} 
	} else if([currentElement isEqualToString:@"rect"]){
		float x; float y; float w; float h;
		for(NSString *aKey in enumerator){
			if([aKey isEqualToString:@"x"]){
				x= [[attributeDict valueForKey:aKey] floatValue];	
			} else if([aKey isEqualToString:@"y"]){
				y= [[attributeDict valueForKey:aKey] floatValue];	
			} else if([aKey isEqualToString:@"width"]){
				w= [[attributeDict valueForKey:aKey] floatValue];
			} else if([aKey isEqualToString:@"height"]){
				h= [[attributeDict valueForKey:aKey] floatValue];
			}
		}
		[rects setValue:[[Pos alloc] initWithX:x Y:y W:w H:h] forKey:[NSString stringWithFormat:@"%d", [pages count]-1]];
	} else if([currentElement isEqualToString:@"path"]){
		for(NSString *aKey in enumerator){
			int pathnum;
			if([aKey isEqualToString:@"name"]){
				[paths addObject:[[Path alloc] initwithName:[attributeDict valueForKey:aKey]]];
			} else if([aKey isEqualToString:@"id"]){
				pathnum=[[attributeDict valueForKey:aKey] integerValue];
			} else if([aKey isEqualToString:@"default"]){
				[[paths objectAtIndex:pathnum] setDefaultPath];
			} 
		}
		[maap addObject:[paths objectAtIndex:[paths count]-1]];
	} else if([currentElement isEqualToString:@"pageref"]){
		for(NSString *aKey in enumerator){
			if([aKey isEqualToString:@"id"]){
				[[[paths objectAtIndex:[paths count]-1] pathnum] addObject:[attributeDict valueForKey:aKey]];
			} 
		}
	}
}

-(NSString *)getTitle{
	return title;
}
@end
